/*
 *	main.c
 *
 *	Xy[X}EX
 *
 *	* Wed Feb 12 00:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

unsigned char BGM[] = {
#include "free_001.c"
};

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define FIELD_COLS	(DISP_X / 8)
#define FIELD_ROWS	(DISP_Y / 8)

#define CHR_WALL	0x90
#define CHR_PLAYER	0x87
#define CHR_MOUSE	0x86

/* tB[h̒l */
#define WALL		1	/*  */
#define MOUSE_LF	2	/* }EX(ړD) */
#define MOUSE_RI	3	/* }EX(EړD) */

#define FINAL_FLOOR	200
#define PLAYER_ROW	(FIELD_ROWS - 3)

typedef struct _GI {
	int time;		/* oߎ */
	int floor;		/* Kx2(ȂK̓r) */
	int mouse_gen_cnt;	/* }EXoJE^ */
	int mouse_move_cnt;	/* }EXړJE^ */
	int player_col;		/* vC[ʒu */
	unsigned char field[FIELD_ROWS][FIELD_COLS];
} GI;

typedef struct _LEVEL {
	int floor;
	int hole_cnt;
	int mouse_gen_itv;
	int mouse_move_itv;
} LEVEL;
const LEVEL levels[] = {
	{  10, 2, SEC(2   ), SEC(0.50) },
	{  25, 2, SEC(1.5 ), SEC(0.40) },
	{  50, 2, SEC(1.3 ), SEC(0.35) },
	{  75, 2, SEC(1.1 ), SEC(0.30) },
	{ 100, 2, SEC(0.9 ), SEC(0.25) },
	{ 125, 3, SEC(0.8 ), SEC(0.20) },
	{ 150, 3, SEC(0.7 ), SEC(0.20) },
	{ 175, 3, SEC(0.6 ), SEC(0.20) },
	{ 999, 3, SEC(0.5 ), SEC(0.20) },
};
const LEVEL*
level_get(int floor)
{
	const LEVEL* level = levels;
	if(floor > 999) floor = 999;
	for(;;) {
		if(floor < level->floor) break;
		level++;
	}
	return level;
}

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int errno;		/* WbCuŒ`ĂȂ̂ */

int now;		/* O[o^C} */
int joy;		/* pbh */
int joy_rep[4];		/* pbh㉺ẼI[gs[gJE^ */

int best_time = SEC(99 * 60 + 59);
GI gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void floor_up(int type);
void field_disp();

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	int retval;

	/* hFǂݍ݂܂B */
	thread_lock();
	retval = loadInst();
	thread_unlock();
	if(retval != 0) {
		grcls(3);
		symbol(4, 34, "drum.binǂݍݎsł", 0, 0);
		symbol(4, 44, "h͍Đ܂", 0, 0);
		wait(3000);
		grcls(-1);
	}

	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */
		 1,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 0,	/* 1:eLXgO/0:w */
		 0);	/* wiF(wʕ\Ȃ̂) */
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned prev;
	       unsigned cur;
	int joy_old, trg, i;

	int pause;

	pause = 0;
	for(;;) {
		/* [VSYNC҂B */
		if(prev == 0) prev = msec();
		do {
			cur = msec();
		} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
		prev = cur;

		/* pbhԎ擾B
		 * VvCuł́AgKI[gs[g̔ōsȂ΂܂B
		 */
		joy_old = joy;
		joy = pad() & 0x00ff;
		trg = (joy ^ joy_old) & joy;
		joy |= trg << 8;
		for(i = 0; i < 4; i++) { /* ㉺E(bit0`3)̂݃I[gs[g */
			if(joy & 1 << i) { /* PAD_*ONȂ  */
				joy_rep[i]++;  /* JEgAbv */
				if(/**joy_rep[i] >= SEC(0.33) &&**/ joy_rep[i] & 1) { /* 莞ԉÂA2t[ */
					joy |= 1 << (i + 8); /* gK */
				}
			} else {
				joy_rep[i] = 0; /* JE^NA */
			}
		}

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause; /* PAUSEԐ؂ւ */
			if(!pause) pausedisp(0);
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(msec() % 1000 < 750) {
			pausedisp(1);
		} else {
			pausedisp(0);
		}
	}
	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result, nn, ss;

	/* ʃNAB */
	bgcls();
	grcls(-1);
	spcls(0);

	/* ^Cg\B */
	locate(3, 4);
	siprintf("  SIMPLE  ");
	locate(3, 5);
	siprintf("SPACEMOUSE");

	/* XRA\B */
	ss = best_time / FPS;
	nn = ss / 100;
	ss = ss % 100;
	if(nn > 99) nn = 99;
	locate(1, 0);
	siprintf("BESTTIME %02d:%02d", ss, nn);
	if(gi.time) {
		ss = gi.time / FPS;
		nn = ss / 100;
		ss = ss % 100;
		if(nn > 99) nn = 99;
		locate(1, 1);
		siprintf("1UP TIME %02d:%02d", ss, nn);
	}

	for(;;) {
		schedule();

		/* Q[JnA܂͏IH */
		if(joy & TRG_A     ) { result =  0; break; }
		if(joy & TRG_SELECT) { result = -1; break; }

		/* vvg\B */
		locate(3, 9);
		siprintf(now % SEC(0.75) < SEC(0.5) ? "[ A ] START" : "           ");
		locate(3, 10);
		siprintf(now % SEC(0.75) < SEC(0.5) ? "[SEL] EXIT " : "           ");
	}
	sound(2);

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	int i, col, row;
	unsigned char cell;
	const LEVEL* level;

	/* Q[B */
	memset(&gi, 0, sizeof gi);
	gi.player_col = FIELD_COLS / 2;
	for(i = 0; i < FIELD_ROWS; i++) floor_up(i);
	gi.floor = 1 << 1;

	pmdplay(BGM);
	for(;;) {
		schedule();
		level = level_get(gi.floor >> 1);

		/* vC[ړB */
		if((joy & TRG_LF) && !gi.field[PLAYER_ROW][gi.player_col - 1]) { gi.player_col--; sound(3); }
		if((joy & TRG_RI) && !gi.field[PLAYER_ROW][gi.player_col + 1]) { gi.player_col++; sound(3); }
		if((joy & TRG_UP) && !gi.field[PLAYER_ROW - 1][gi.player_col]) {
			gi.floor++;
			floor_up(gi.floor);
			if(gi.floor >> 1 >= FINAL_FLOOR - 4) memset(&gi.field[0][1], 0, FIELD_COLS - 2);
			if(gi.floor >> 1 >= FINAL_FLOOR) goto CLEAR;
			sound(1);
		}

		/* }EXoB */
		gi.mouse_gen_cnt++;
		if(gi.mouse_gen_cnt >= level->mouse_gen_itv) {
			gi.mouse_gen_cnt = 0;
			for(i = 0; i < 10; i++) { /* 10܂ŃgC */
				col = 1 + rnd(FIELD_COLS - 2); /* E[͏ */
				if(gi.field[0][col]) continue;
				gi.field[0][col] = rnd(2) & 1 ? MOUSE_LF : MOUSE_RI;
				sound(0);
				break; /* oł甲 */
			}
		}

		/* }EXړB */
		gi.mouse_move_cnt++;
		if(gi.mouse_move_cnt >= level->mouse_move_itv) {
			gi.mouse_move_cnt = 0;
			for(row = 0; row < FIELD_ROWS; row++) {
				for(col = 1; col < FIELD_COLS - 1; col++) { /* E[͂肦Ȃ */
					cell = gi.field[row][col];
					switch(cell) {
					case MOUSE_LF:
					case MOUSE_RI:
						if(row == FIELD_ROWS - 1) { /* ʉɏ */
							gi.field[row][col] = 0;
							goto L10;
						}
						if(!gi.field[row + 1][col]) { /* ړ */
							gi.field[row][col] = 0;
							gi.field[row + 1][col] = cell | 0x80;
							goto L10;
						}
						if(cell == MOUSE_LF) {
							if(!gi.field[row][col - 1]) { /* ړ */
								gi.field[row][col] = 0;
								gi.field[row][col - 1] = cell | 0x80;
							} else if(!gi.field[row][col + 1]) { /* ]ĉEړ */
								gi.field[row][col] = 0;
								gi.field[row][col + 1] = MOUSE_RI | 0x80;
							}
						} else {
							if(!gi.field[row][col + 1]) { /* Eړ */
								gi.field[row][col] = 0;
								gi.field[row][col + 1] = cell | 0x80;
							} else if(!gi.field[row][col - 1]) { /* ]čړ */
								gi.field[row][col] = 0;
								gi.field[row][col - 1] = MOUSE_LF | 0x80;
							}
						}
L10:
						break;
					}
				}
			}
			for(row = 0; row < FIELD_ROWS; row++) {
				for(col = 1; col < FIELD_COLS - 1; col++) { /* E[͂肦Ȃ */
					gi.field[row][col] &= ~0x80;
				}
			}
		}

		/* 蔻B */
		if(gi.field[PLAYER_ROW][gi.player_col]) goto GAMEOVER;

		field_disp();
		gi.time++;
	}
CLEAR:
	pmdstop();
	sound(2);
	field_disp();
	locate((FIELD_COLS - 16) / 2, FIELD_ROWS / 2);
	siprintf("CONGRATULATIONS!");
	for(i = 0; i < SEC(3); i++) {
		schedule();
	}
	if(gi.time < best_time) best_time = gi.time;
	return;

GAMEOVER:
	pmdstop();
	sound(2);
	field_disp();
	locate((FIELD_COLS - 8) / 2, FIELD_ROWS / 2);
	siprintf("GAMEOVER");
	for(i = 0; i < SEC(3); i++) {
		schedule();
	}
	gi.time = 0;
	return;
}

/****************************************************************************
 *	floor_up
 ****************************************************************************/

void
floor_up(int type)
{
	int i, n, col;
	const LEVEL* level = level_get(gi.floor >> 1);

	memmove(&gi.field[1][0], &gi.field[0][0], FIELD_COLS * (FIELD_ROWS - 1));

	if(!(type & 1)) {
		gi.field[0][             0] = WALL;
		memset(&gi.field[0][1], 0, FIELD_COLS - 2);
		gi.field[0][FIELD_COLS - 1] = WALL;
	} else {
		memset(&gi.field[0][0], WALL, FIELD_COLS);
		n = 0;
		do {
			for(i = 0; i < 10; i++) { /* ɂ10܂ŃgC */
				col = 1 + rnd(FIELD_COLS - 2); /* E[͏ */
				if(!gi.field[0][col]    ) continue;
				if(!gi.field[0][col - 1]) continue;
				if(!gi.field[0][col + 1]) continue;
				gi.field[0][col] = 0;
				n++;
				break; /* 烊gCȂ */
			}
		} while(n < level->hole_cnt);
	}
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp()
{
	int obj, chr, col, row, nn, ss, i;
	unsigned char cell;
	char str[32];

	obj = 0;

	/* tB[h\B */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = gi.field[row][col];
			switch(cell) {
			case WALL:
				chr = CHR_WALL;
				break;
			case MOUSE_LF:
			case MOUSE_RI:
				chr = CHR_MOUSE;
				break;
			default:
				chr = 0;
				break;
			}
			bgput(col, row, chr);
		}
	}

	/* vC[\B */
	spdisp(obj++, gi.player_col * 8, PLAYER_ROW * 8, CHR_PLAYER);

	/* KAԕ\B */
	ss = gi.time / FPS;
	nn = ss / 100;
	ss = ss % 100;
	if(nn > 99) nn = 99;
	sprintf(str, " FLOOR%3d %02d:%02d ", gi.floor >> 1, nn, ss);
	for(i = 0; i < FIELD_COLS; i++) {
		spdisp(obj++, i * 8, (FIELD_ROWS - 1) * 8, str[i]);
	}

	spcls(obj);
}
